code	segment	'code'
	assume	cs:code,ds:code

	org	2ch
envseg	label	word			; pointer to env seg

	org	100h
start:	jmp	near ptr init		; jump to install routine
	dw	0

new2f:	cmp	ax,4310h		; get XMS driver address
	jne	start
	push	cs			; point to pre-handler
	pop	es
	mov	bx,offset xmsfn
	iret

xmsfn:	jmp	short chkfn		; customary entry arrangement
	nop
	nop
	nop
chkfn:	or	ah,ah			; get XMS version?
	jne	xmsdr
	push	cs			; call XMS driver
	call	xmsdr
	mov	dx,1			; HMA exists
	retf
xmsdr:
	db	0eah			; far jump opcode
drvad	dd	0			; XMS driver address

init:	mov	ax,4300h		; XMS - install check
	int	2fh
	cmp	al,80h			; XMS installed?
	je	xmsok
	ret

xmsok:	mov	al,10h			; XMS - get driver address
	int	2fh
	mov	word ptr drvad,bx
	mov	word ptr drvad+2,es

	mov	ax,352fh		; create jump to old handler
	int	21h
	inc	byte ptr start
	mov	word ptr start+1,bx
	mov	word ptr start+3,es

	mov	dx,offset new2f		; hook into chain
	mov	ah,25h
	int	21h

	mov	es,envseg		; free env seg
	mov	ah,49h
	int	21h

	mov	dx,0013h		; terminate leaving DX paras resident
	mov	ax,3100h
	int	21h

code	ends

	end	start



